using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

using Telerik.Web.UI;

using BE;
using BL;
using Utilitaria;


public partial class InstUpd_TipodeConversionMoneda : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["Usuario"] == null)
        {
            ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CloseAndRebind();", true);
        }
        this.txtNombre.Focus();
        if (!IsPostBack)
        {

            llenaCombo();
            if (ViewState["TipoPersonaID"] != null) { BuscaRegistro(); } else { this.ddlEstado2.SelectedValue = Utilitaria.Cls_Enums.EstadoModulos.Activo; }
        }

        //ddlTipoFormatoGGPP.Filter = (RadComboBoxFilter)Convert.ToInt32(2);
    }


    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);

        if (Request.QueryString["TipoPersonaID"] == null)
        {
            this.btnGuardar.Text = "  Crear  "; 
        }
        else
        {
            this.btnGuardar.Text = "Actualizar";
            ViewState["TipoPersonaID"] = Request.QueryString["TipoPersonaID"].ToString().Trim();
        }
    }

    private void llenaCombo()
    {
        this.ddlEstado2.Items.Insert(0, new RadComboBoxItem("Activo"));
        this.ddlEstado2.Items[0].Value = Utilitaria.Cls_Enums.EstadoModulos.Activo;

        this.ddlEstado2.Items.Insert(1, new RadComboBoxItem("Inactivo"));
        this.ddlEstado2.Items[1].Value = Utilitaria.Cls_Enums.EstadoModulos.Inactivo;
    }

    private void limpiarCampos()
    {
        ViewState["TipoPersonaID"] = "";
        this.txtNombre.Text = String.Empty;
        this.ddlEstado2.SelectedValue = Utilitaria.Cls_Enums.EstadoModulos.Todos;
    }

    private void BuscaRegistro()
    {
        BETipoPersona objet_TipoPersona = new BETipoPersona();
        BLTipoPersona objlg_TipoPersona = new BLTipoPersona();
        List<BETipoPersona> Datos;

        Datos = objlg_TipoPersona.fnSelTipoPersonaDin("TipoPersonaID=" + Convert.ToString(ViewState["TipoPersonaID"]), "");

        ViewState["TipoPersonaID"] = Datos[0].TipoPersonaID;

        // Inicio Variables auditoras ///
        ViewState["NombreTipoPersona"] = Datos[0].NombreTipoPersona;
        ViewState["Estado"] = Datos[0].Estado;
        ///////FIN//////////

        this.txtNombre.Text = Convert.ToString(ViewState["NombreTipoPersona"]).Trim();
        this.ddlEstado2.SelectedValue = Convert.ToString(ViewState["Estado"]);

        objet_TipoPersona = null;
        objlg_TipoPersona = null;
        Datos = null;
            

    }

    protected void btnGuardar_Click(object sender, EventArgs e)
    {

        BETipoPersona objet_TipoPersona = new BETipoPersona();
        BLTipoPersona objlg_TipoPersona = new BLTipoPersona();

        String strTipoPersonaID = Convert.ToString(ViewState["TipoPersonaID"]);
        String strRegistro;
        String strActualiza;

        ViewState["New_NombreTipoPersona"] = this.txtNombre.Text;
        ViewState["New_Estado"] = Convert.ToByte(this.ddlEstado2.SelectedValue);

        objet_TipoPersona.TipoPersonaID = strTipoPersonaID;
        objet_TipoPersona.NombreTipoPersona = Convert.ToString(ViewState["New_NombreTipoPersona"]).Trim();
        objet_TipoPersona.Estado = Convert.ToByte(ViewState["New_Estado"]);

        strRegistro = "<<Creo TipoPersona>>" +
                      "\n<NombreTipoPersona>=" + ViewState["New_NombreTipoPersona"] +
                      "\n<Estado>=" + ViewState["New_Estado"];

        //Ingresa
        objet_TipoPersona.BEAuditores.UsuarioID = Convert.ToInt32(Session["UsuarioID"]);
        objet_TipoPersona.BEAuditores.Movimiento = strRegistro;
        objet_TipoPersona.BEAuditores.UsuarioIdAutorizado = 0;
        objet_TipoPersona.BEAuditores.IPEquipo = Cls_Enums.f_DatosPC.IPPC;
        objet_TipoPersona.BEAuditores.UsuarioActualEquipo = Cls_Enums.f_DatosPC.UsuarioPC;
        objet_TipoPersona.BEAuditores.NombreEquipo = Cls_Enums.f_DatosPC.NombrePC;
        objet_TipoPersona.BEAuditores.TablaMovimientoID = Cls_Enums.TablaMovimientos.TipoPersona;

        if (strTipoPersonaID != String.Empty)
        {
            //Update
            strRegistro = "<<Actualiza TipoPersona>>" +
                          "\n<NombreTipoPersona>=" + ViewState["NombreTipoPersona"] +
                          "\n<Estado>=" + ViewState["Estado"];

            strActualiza = "<<Actualiza TipoPersona>>" +
                           "\n<NombreTipoPersona>=" + ViewState["New_NombreTipoPersona"] +
                           "\n<Estado>=" + ViewState["New_Estado"];

            objet_TipoPersona.BEAuditores.Movimiento = strRegistro;
            objet_TipoPersona.BEAuditores.MovimientoUltimo = strActualiza;
            ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CloseAndRebind();", true);
        }
        else
        {
            ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CloseAndRebind('navigateToInserted');", true);
        }

        int registro = objlg_TipoPersona.fnInsUpdTipoPersona(objet_TipoPersona);
        if (registro > 0) { showMessage("Los Datos que ingreso ya esta registrado"); return; };

        objet_TipoPersona = null;
        objlg_TipoPersona = null;
        this.limpiarCampos();

    }

    protected void btnVolver_Click(object sender, EventArgs e)
    {
        ClientScript.RegisterStartupScript(Page.GetType(), "mykey", "CancelEdit();", true);
        this.limpiarCampos();
    }
    protected void showMessage(string strMessage)
    {
        ScriptManager.RegisterStartupScript(this, this.GetType(), "myscript", "alert('" + strMessage + "');", true);

    }

}
